<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: PregelTIGL&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classPregelTIGL-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PregelTIGL&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__interface__engine.html">Interface</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Top level class for the Pregel engine <br />
The class provides the high-level interface to executing the pregel engine. It allocates objects of the core components of the engine, including the data container, the compute engine, and the communication engine. It is has a generic template structure that is prototyped to the particular algorithm vertex definition and data combiner.  
 <a href="classPregelTIGL.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tigl_8hpp_source.html">tigl.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a00ae3aa10a65f84f5f77567ecc2f3025"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a00ae3aa10a65f84f5f77567ecc2f3025">PregelTIGL</a> (bool isDirected, uint64 numTotalVertices, uint32 idDevice=0, uint32 totalDevices=1, int allocThreads=NUM_OMP_THREADS)</td></tr>
<tr class="memdesc:a00ae3aa10a65f84f5f77567ecc2f3025"><td class="mdescLeft">&#160;</td><td class="mdescRight">: constructor performs necessary memory allocations  <a href="#a00ae3aa10a65f84f5f77567ecc2f3025">More...</a><br /></td></tr>
<tr class="separator:a00ae3aa10a65f84f5f77567ecc2f3025"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a053628d7cc383525c539bdabad44b8b6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a053628d7cc383525c539bdabad44b8b6"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a053628d7cc383525c539bdabad44b8b6">reset</a> ()</td></tr>
<tr class="memdesc:a053628d7cc383525c539bdabad44b8b6"><td class="mdescLeft">&#160;</td><td class="mdescRight">clearing the memory allocation for the graph <br /></td></tr>
<tr class="separator:a053628d7cc383525c539bdabad44b8b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b69c604bdb1488a1aff1ff3d2b3b216"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a4b69c604bdb1488a1aff1ff3d2b3b216">readSubgraphFromFile</a> (char *fileName)</td></tr>
<tr class="memdesc:a4b69c604bdb1488a1aff1ff3d2b3b216"><td class="mdescLeft">&#160;</td><td class="mdescRight">reading subgraph in the form of adjacency list  <a href="#a4b69c604bdb1488a1aff1ff3d2b3b216">More...</a><br /></td></tr>
<tr class="separator:a4b69c604bdb1488a1aff1ff3d2b3b216"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8f6916248f2a22f15366c708781b9e43"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a8f6916248f2a22f15366c708781b9e43">initGraph</a> (vector&lt; ALG_VERTEX_TYPE &gt; &amp;verticesList)</td></tr>
<tr class="memdesc:a8f6916248f2a22f15366c708781b9e43"><td class="mdescLeft">&#160;</td><td class="mdescRight">initialization the graph from a vertices list  <a href="#a8f6916248f2a22f15366c708781b9e43">More...</a><br /></td></tr>
<tr class="separator:a8f6916248f2a22f15366c708781b9e43"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae185ca60d0fe31df878dca4ddfe7d991"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#ae185ca60d0fe31df878dca4ddfe7d991">run</a> (uint32 maxSS=DEFAULT_MAXIMUM_SS, ALG_INIT *initParams=0)</td></tr>
<tr class="memdesc:ae185ca60d0fe31df878dca4ddfe7d991"><td class="mdescLeft">&#160;</td><td class="mdescRight">the core function for Pregel engine execution it performs the engine initialization, handles the vertex processing at each superstep, and the called the communication manager to send/receive messages after each superstep it also handles the algorithm termination procedure  <a href="#ae185ca60d0fe31df878dca4ddfe7d991">More...</a><br /></td></tr>
<tr class="separator:ae185ca60d0fe31df878dca4ddfe7d991"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae0bb45fbda44e306a8d5c9f1462f7788"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:ae0bb45fbda44e306a8d5c9f1462f7788"><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#ae0bb45fbda44e306a8d5c9f1462f7788">computeSNR</a> (vector&lt; CVertex &gt; &amp;refVect)</td></tr>
<tr class="memdesc:ae0bb45fbda44e306a8d5c9f1462f7788"><td class="mdescLeft">&#160;</td><td class="mdescRight">computes the SNR (in dB) between the computed values and values from a benchmark implementation  <a href="#ae0bb45fbda44e306a8d5c9f1462f7788">More...</a><br /></td></tr>
<tr class="separator:ae0bb45fbda44e306a8d5c9f1462f7788"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c994c596876a990f3d50ccbdfe67dc1"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:a3c994c596876a990f3d50ccbdfe67dc1"><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a3c994c596876a990f3d50ccbdfe67dc1">computeNormalizedSNR</a> (vector&lt; CVertex &gt; &amp;refVect)</td></tr>
<tr class="separator:a3c994c596876a990f3d50ccbdfe67dc1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adab02e106580c693624ab0c09f990c3f"><td class="memTemplParams" colspan="2">template&lt;typename CVertex &gt; </td></tr>
<tr class="memitem:adab02e106580c693624ab0c09f990c3f"><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#adab02e106580c693624ab0c09f990c3f">computeMSE</a> (vector&lt; CVertex &gt; &amp;refVect)</td></tr>
<tr class="memdesc:adab02e106580c693624ab0c09f990c3f"><td class="mdescLeft">&#160;</td><td class="mdescRight">computes the Mean Square Error (MSE) between the computed value and a reference value  <a href="#adab02e106580c693624ab0c09f990c3f">More...</a><br /></td></tr>
<tr class="separator:adab02e106580c693624ab0c09f990c3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a625ac02721692d20d874c59f2b60db31"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a625ac02721692d20d874c59f2b60db31"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a625ac02721692d20d874c59f2b60db31">memory_usage</a> ()</td></tr>
<tr class="memdesc:a625ac02721692d20d874c59f2b60db31"><td class="mdescLeft">&#160;</td><td class="mdescRight">compute the approximate overall memory usage <br /></td></tr>
<tr class="separator:a625ac02721692d20d874c59f2b60db31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae402e1a07b88e4d16fa325ce6905a9ea"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae402e1a07b88e4d16fa325ce6905a9ea"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#ae402e1a07b88e4d16fa325ce6905a9ea">get_num_vertices</a> ()</td></tr>
<tr class="memdesc:ae402e1a07b88e4d16fa325ce6905a9ea"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns number of local vertices <br /></td></tr>
<tr class="separator:ae402e1a07b88e4d16fa325ce6905a9ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a867d99dcfbbcbe77daf3d609d11f302a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a867d99dcfbbcbe77daf3d609d11f302a"></a>
ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a867d99dcfbbcbe77daf3d609d11f302a">get_num_edges</a> ()</td></tr>
<tr class="memdesc:a867d99dcfbbcbe77daf3d609d11f302a"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the total number of edges <br /></td></tr>
<tr class="separator:a867d99dcfbbcbe77daf3d609d11f302a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26eb72e0a3c85dd4c21f9e605893e960"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a26eb72e0a3c85dd4c21f9e605893e960"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a26eb72e0a3c85dd4c21f9e605893e960">MaxCollision</a> ()</td></tr>
<tr class="memdesc:a26eb72e0a3c85dd4c21f9e605893e960"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the maximum number of collisions in the position buffer <br /></td></tr>
<tr class="separator:a26eb72e0a3c85dd4c21f9e605893e960"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:ac4398cea50a47d510ecb443ff2f00608"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac4398cea50a47d510ecb443ff2f00608"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#ac4398cea50a47d510ecb443ff2f00608">deviceID</a></td></tr>
<tr class="memdesc:ac4398cea50a47d510ecb443ff2f00608"><td class="mdescLeft">&#160;</td><td class="mdescRight">ID of the current device. <br /></td></tr>
<tr class="separator:ac4398cea50a47d510ecb443ff2f00608"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb1e36ddb7bdc5cebc818ede86a99112"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abb1e36ddb7bdc5cebc818ede86a99112"></a>
<a class="el" href="classPregelDataContainer.html">DATA_CONTAINER_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#abb1e36ddb7bdc5cebc818ede86a99112">dataManager</a></td></tr>
<tr class="memdesc:abb1e36ddb7bdc5cebc818ede86a99112"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classPregelDataContainer.html" title="Basic graph container for each Device in Pregel system. It inherits the subgraph class and adds the m...">PregelDataContainer</a> object (allocated in the constructor) <br /></td></tr>
<tr class="separator:abb1e36ddb7bdc5cebc818ede86a99112"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0512db85aa1f1d4c22fcd580cfcb73d9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0512db85aa1f1d4c22fcd580cfcb73d9"></a>
<a class="el" href="classPregelCommunicator.html">COMMUNICATOR_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a0512db85aa1f1d4c22fcd580cfcb73d9">communicationManager</a></td></tr>
<tr class="memdesc:a0512db85aa1f1d4c22fcd580cfcb73d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classPregelCommunicator.html" title="core communicator class definition It handles all the MPI communication between devices (including bo...">PregelCommunicator</a> object (allocated in the constructor) <br /></td></tr>
<tr class="separator:a0512db85aa1f1d4c22fcd580cfcb73d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb6ee9ef49c512e6c93a60b34432e7dc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acb6ee9ef49c512e6c93a60b34432e7dc"></a>
<a class="el" href="classPregelComputeManager.html">COMPUTATION_TYPE</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#acb6ee9ef49c512e6c93a60b34432e7dc">computationManager</a></td></tr>
<tr class="memdesc:acb6ee9ef49c512e6c93a60b34432e7dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to <a class="el" href="classPregelComputeManager.html" title="Core Computation class for the Pregel engine it handles all the superstep processing including: verte...">PregelComputeManager</a> object (allocated in the constructor) <br /></td></tr>
<tr class="separator:acb6ee9ef49c512e6c93a60b34432e7dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e56460ff815ebe5dc2b29de7219842c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3e56460ff815ebe5dc2b29de7219842c"></a>
ALG_COMBINER *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a3e56460ff815ebe5dc2b29de7219842c">combiner</a></td></tr>
<tr class="memdesc:a3e56460ff815ebe5dc2b29de7219842c"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to user-defined combiner object (allocated in the constructor) <br /></td></tr>
<tr class="separator:a3e56460ff815ebe5dc2b29de7219842c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b1064eb38ead6372033148bf25d88ff"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5b1064eb38ead6372033148bf25d88ff"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a5b1064eb38ead6372033148bf25d88ff">numDevices</a></td></tr>
<tr class="memdesc:a5b1064eb38ead6372033148bf25d88ff"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of devices (1 if MPI is not used) <br /></td></tr>
<tr class="separator:a5b1064eb38ead6372033148bf25d88ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a611534eeb87b0b756c5f9eab9f14b893"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a611534eeb87b0b756c5f9eab9f14b893"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#a611534eeb87b0b756c5f9eab9f14b893">numLocalVertices</a></td></tr>
<tr class="memdesc:a611534eeb87b0b756c5f9eab9f14b893"><td class="mdescLeft">&#160;</td><td class="mdescRight">number of local vertices <br /></td></tr>
<tr class="separator:a611534eeb87b0b756c5f9eab9f14b893"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1614eaedc6ea59b6af6a79ef1245767"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af1614eaedc6ea59b6af6a79ef1245767"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelTIGL.html#af1614eaedc6ea59b6af6a79ef1245767">flagDirected</a></td></tr>
<tr class="memdesc:af1614eaedc6ea59b6af6a79ef1245767"><td class="mdescLeft">&#160;</td><td class="mdescRight">directed/undirected graph <br /></td></tr>
<tr class="separator:af1614eaedc6ea59b6af6a79ef1245767"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename ALG_VERTEX_TYPE, typename ALG_COMBINER&gt;<br />
class PregelTIGL&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;</h3>

<p>Top level class for the Pregel engine <br />
The class provides the high-level interface to executing the pregel engine. It allocates objects of the core components of the engine, including the data container, the compute engine, and the communication engine. It is has a generic template structure that is prototyped to the particular algorithm vertex definition and data combiner. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a00ae3aa10a65f84f5f77567ecc2f3025"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPregelTIGL.html">PregelTIGL</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::<a class="el" href="classPregelTIGL.html">PregelTIGL</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>isDirected</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint64&#160;</td>
          <td class="paramname"><em>numTotalVertices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>idDevice</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>totalDevices</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>allocThreads</em> = <code>NUM_OMP_THREADS</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>: constructor performs necessary memory allocations </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">isDirected</td><td>true if the graph is directed, false if the graph is undirected </td></tr>
    <tr><td class="paramname">numTotalVertices</td><td>total number of vertices on all devices of the whole graph </td></tr>
    <tr><td class="paramname">the</td><td>rank of the current device (set to zero for single device) </td></tr>
    <tr><td class="paramname">the</td><td>total number of devices (set to one for single device) </td></tr>
    <tr><td class="paramname">the</td><td>total number of parallel allocated buffer (special setting that is not needed for general use). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="adab02e106580c693624ab0c09f990c3f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double <a class="el" href="classPregelTIGL.html">PregelTIGL</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::computeMSE </td>
          <td>(</td>
          <td class="paramtype">vector&lt; CVertex &gt; &amp;&#160;</td>
          <td class="paramname"><em>refVect</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>computes the Mean Square Error (MSE) between the computed value and a reference value </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">refVect</td><td>vertices list that has the reference implementation results </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>MSE between the computed output and the reference output. In MPI environment device with rank 0 collects the SNR from all other devices </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3c994c596876a990f3d50ccbdfe67dc1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double <a class="el" href="classPregelTIGL.html">PregelTIGL</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::computeNormalizedSNR </td>
          <td>(</td>
          <td class="paramtype">vector&lt; CVertex &gt; &amp;&#160;</td>
          <td class="paramname"><em>refVect</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">refVect</td><td>vertices list that has the reference implementation results </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>snr in dB between the computed output and the reference output. In MPI environment device with rank 0 collects the SNR from all other devices </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae0bb45fbda44e306a8d5c9f1462f7788"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
<div class="memtemplate">
template&lt;typename CVertex &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double <a class="el" href="classPregelTIGL.html">PregelTIGL</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::computeSNR </td>
          <td>(</td>
          <td class="paramtype">vector&lt; CVertex &gt; &amp;&#160;</td>
          <td class="paramname"><em>refVect</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>computes the SNR (in dB) between the computed values and values from a benchmark implementation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">refVect</td><td>vertices list that has the reference implementation results </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>snr in dB between the computed output and the reference output. In MPI environment device with rank 0 collects the SNR from all other devices </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8f6916248f2a22f15366c708781b9e43"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classPregelTIGL.html">PregelTIGL</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::initGraph </td>
          <td>(</td>
          <td class="paramtype">vector&lt; ALG_VERTEX_TYPE &gt; &amp;&#160;</td>
          <td class="paramname"><em>verticesList</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>initialization the graph from a vertices list </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertices</td><td>list that contains the subgraph for the current device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4b69c604bdb1488a1aff1ff3d2b3b216"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classPregelTIGL.html">PregelTIGL</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::readSubgraphFromFile </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>fileName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reading subgraph in the form of adjacency list </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fileName</td><td>file name of the subgraph for the device </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>if no error, false if in error </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae185ca60d0fe31df878dca4ddfe7d991"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_VERTEX_TYPE , typename ALG_COMBINER &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classPregelTIGL.html">PregelTIGL</a>&lt; ALG_VERTEX_TYPE, ALG_COMBINER &gt;::run </td>
          <td>(</td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>maxSS</em> = <code>DEFAULT_MAXIMUM_SS</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ALG_INIT *&#160;</td>
          <td class="paramname"><em>initParams</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>the core function for Pregel engine execution it performs the engine initialization, handles the vertex processing at each superstep, and the called the communication manager to send/receive messages after each superstep it also handles the algorithm termination procedure </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxSS</td><td>the maximum number of supersteps for the graph algorithm </td></tr>
    <tr><td class="paramname">initParams</td><td>pointer to the intialization parameters for the graph algorithm </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>if not error, false if an error takes place </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/standard/api/<a class="el" href="tigl_8hpp_source.html">tigl.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
